//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TMainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TMainForm *MainForm;
//---------------------------------------------------------------------------
TList*      TMainForm_List = NULL;
//---------------------------------------------------------------------------
#include "TSplashForm.h"
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
Next_Form = NULL;
Prev_Form = NULL;
if (TMainForm_List==NULL)
    {
    TMainForm_List = new TList();
    if (TMainForm_List) TMainForm_List->Add( this );
    }
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
if (TMainForm_List!=NULL)
    if (TMainForm_List->Items[0]==this)
        {
        delete TMainForm_List;
        TMainForm_List = NULL;
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HomeClick(TObject *Sender)
{
WideString URL = "file:///d:/bcb-tools.com/bcb-tools-www/Welcome.htm";
Edit1->Text = URL;
CppWebBrowser1->Navigate( URL );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
/*
if (Memo1->Visible) Memo1->Width = ClientWidth * 3 / 10;
else Memo1->Width = 0;

Memo1->Left = ClientWidth - Memo1->Width;
Memo1->Top = ControlsPanel->Height;
Memo1->Height = ClientHeight - Memo1->Top;

BrowsePanel->Top = Memo1->Top;
BrowsePanel->Width = ClientWidth - Memo1->Width;
BrowsePanel->Height = Memo1->Height - ProgressBar1->Height;

ProgressBar1->Top = ClientHeight - ProgressBar1->Height;
ProgressBar1->Width = BrowsePanel->Width;
*/
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BackClick(TObject *Sender)
{
CppWebBrowser1->GoBack();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ForwardClick(TObject *Sender)
{
CppWebBrowser1->GoForward();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StopClick(TObject *Sender)
{
CppWebBrowser1->Stop();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::RefreshClick(TObject *Sender)
{
CppWebBrowser1->Refresh2();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::CppWebBrowser1BeforeNavigate2(TObject *Sender,
      LPDISPATCH pDisp, TVariant *URL, TVariant *Flags,
      TVariant *TargetFrameName, TVariant *PostData, TVariant *Headers,
      TOLEBOOL *Cancel)
{
Memo1->Lines->Add(">> Before Navigate: Browsing to "+*URL);
}
//---------------------------------------------------------------------------



void __fastcall TMainForm::CppWebBrowser1DocumentComplete(TObject *Sender,
      LPDISPATCH pDisp, TVariant *URL)
{
Memo1->Lines->Add(">> Document Complete: "+*URL);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1DownloadBegin(TObject *Sender)
{
Memo1->Lines->Add(">> Download Begin");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1DownloadComplete(TObject *Sender)
{
Memo1->Lines->Add(">> Download Complete");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1NavigateComplete2(TObject *Sender,
      LPDISPATCH pDisp, TVariant *URL)
{
Memo1->Lines->Add(">> Navigate Complete: "+*URL);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1NewWindow2(TObject *Sender,
      LPDISPATCH *ppDisp, TOLEBOOL *Cancel)
{
Memo1->Lines->Add(">> New Window");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1ProgressChange(TObject *Sender,
      long Progress, long ProgressMax)
{
AnsiString percent = "unknown";
if (Progress==-1) percent = "100";
else if (ProgressMax!=0)
    {
    int temp = Progress * 100 / ProgressMax;
    percent = IntToStr(temp);
    }
Memo1->Lines->Add(">> Progress Change: ("+IntToStr(Progress)+"/"+IntToStr(ProgressMax)+") "+percent+"%");

ProgressBar1->Min = 0;
ProgressBar1->Position = Progress;
ProgressBar1->Max = ProgressMax;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1TitleChange(TObject *Sender,
      BSTR URL)
{
AnsiString new_title = URL;
if (new_title != Last_Title)
    {
    Memo1->Lines->Add(">> Title Change: "+new_title);
    Last_Title = new_title;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1CommandStateChange(TObject *Sender,
      long Command, TOLEBOOL Enable)
{
Memo1->Lines->Add(">> Command State Change:" );
switch (Command)
    {
    case CSC_NAVIGATEFORWARD:   Memo1->Lines->Add("Navigate Forwards" ); break;
    case CSC_NAVIGATEBACK:      Memo1->Lines->Add("Navigate Back" ); break;
    case CSC_UPDATECOMMANDS:

        Memo1->Lines->Add("Command State Changed: Update Commands" );
        if (CppWebBrowser1->Busy) Memo1->Lines->Add( "Status: Busy" );
        Memo1->Lines->Add("Location Name: "+CppWebBrowser1->LocationName );
        Memo1->Lines->Add("Location URL: "+CppWebBrowser1->LocationURL );
//        if (CppWebBrowser1->ReadyState==READYSTATE_UNINITIALIZED)  Memo1->Lines->Add("Ready State: Uninitialized"); break;
//        if (CppWebBrowser1->ReadyState==READYSTATE_LOADING)        Memo1->Lines->Add("Ready State: Loading"); break;
//        if (CppWebBrowser1->ReadyState==READYSTATE_LOADED)         Memo1->Lines->Add("Ready State: Loaded"); break;
//        if (CppWebBrowser1->ReadyState==READYSTATE_INTERACTIVE)    Memo1->Lines->Add("Ready State: Interactive"); break;
//        if (CppWebBrowser1->ReadyState==READYSTATE_COMPLETE)       Memo1->Lines->Add("Ready State: Complete"); break;
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1Visible(TObject *Sender,
      TOLEBOOL Visible)
{
Memo1->Lines->Add(">> Visible");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ClearClick(TObject *Sender)
{
Memo1->Lines->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GoClick(TObject *Sender)
{
if (Edit1->Text!="")
    {
    WideString URL = Edit1->Text;
    CppWebBrowser1->Navigate( URL );
    }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::TraceClick(TObject *Sender)
{
Memo1->Visible = !Memo1->Visible;
OnResize(this);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormShow(TObject *Sender)
{
SplashForm->ShowModal();
Width = Screen->Width;
Height = Screen->Height;
FormResize(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::NewWindowClick(TObject *Sender)
{
TMainForm* main_form = new TMainForm(this);
if (main_form)
    {
    TMainForm_List->Add( main_form );
    main_form->Show();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CloseWindowClick(TObject *Sender)
{
int temp = TMainForm_List->IndexOf(this);
if (temp!=0)
    {
    TMainForm_List->Delete( temp );
    TMainForm_List->Pack();
    }
Close();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::BrowseClick(TObject *Sender)
{
if (OpenDialog1->Execute())
    {
    WideString URL = OpenDialog1->FileName;
    CppWebBrowser1->Navigate( URL );
    }
}
//---------------------------------------------------------------------------



void __fastcall TMainForm::ViewSourceClick(TObject *Sender)
{
//ShowMessage( CPPWebBrowser1 );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1PropertyChange(TObject *Sender,
      BSTR URL)
{
AnsiString url = URL;
Memo1->Lines->Add("Property Change:" + url );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CppWebBrowser1StatusTextChange(TObject *Sender,
      BSTR URL)
{
WideString url = URL;
Caption = url;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BitBtn2Click(TObject *Sender)
{
Memo2->Visible = !Memo2->Visible;
Memo3->Visible = Memo2->Visible;
OnResize(this);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NMHTTP1Success(CmdType Cmd)
{
  if (NMHTTP1->CookieIn != "")
//    Memo4->Text = NMHTTP1->CookieIn;
//  Memo1->Text = NMHTTP1->Header;
  Memo2->Text = NMHTTP1->Body;
  switch(Cmd)
    {
      case CmdGET: Memo3->Lines->Add("HTTP GET Successful");
      case CmdPOST: Memo3->Lines->Add("HTTP POST Successful");
      case CmdHEAD: Memo3->Lines->Add("HTTP HEAD Successful");

      case CmdOPTIONS: Memo3->Lines->Add("HTTP OPTIONS Successful");
      case CmdTRACE: Memo3->Lines->Add("HTTP TRACE Successful");
      case CmdPUT: Memo3->Lines->Add("HTTP PUT Successful");
      case CmdDELETE: Memo3->Lines->Add("HTTP DELETE Successful");
    }
}
//---------------------------------------------------------------------------

