//---------------------------------------------------------------------------

#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "SHDocVw_OCX.h"
#include <OleCtrls.hpp>
#include <HTTPApp.hpp>
#include <ScktComp.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <NMHttp.hpp>
#include <Psock.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *BrowsePanel;
    TCppWebBrowser *CppWebBrowser1;
    TMemo *Memo1;
    TBitBtn *Clear;
    TBitBtn *NewWindow;
    TBitBtn *CloseWindow;
    TBitBtn *Trace;
    TPanel *ControlsPanel;
    TBitBtn *Home;
    TBitBtn *Back;
    TBitBtn *Forward;
    TBitBtn *Stop;
    TBitBtn *Refresh;
    TBitBtn *Top;
    TBitBtn *Bottom;
    TPanel *LogoPanel;
    TImage *Image1;
    TPanel *NavigationPanel;
    TEdit *Edit1;
    TBitBtn *Go;
    TBitBtn *Browse;
    TOpenDialog *OpenDialog1;
    TBitBtn *ShowHideControlsPanel;
    TBitBtn *BitBtn1;
    TProgressBar *ProgressBar1;
    TBitBtn *ViewSource;
    TNMHTTP *NMHTTP1;
    TMemo *Memo2;
    TBitBtn *BitBtn2;
    TMemo *Memo3;
    void __fastcall HomeClick(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall BackClick(TObject *Sender);
    void __fastcall ForwardClick(TObject *Sender);
    void __fastcall StopClick(TObject *Sender);
    void __fastcall RefreshClick(TObject *Sender);
    void __fastcall CppWebBrowser1BeforeNavigate2(TObject *Sender,
          LPDISPATCH pDisp, TVariant *URL, TVariant *Flags,
          TVariant *TargetFrameName, TVariant *PostData, TVariant *Headers,
          TOLEBOOL *Cancel);
    void __fastcall CppWebBrowser1DocumentComplete(TObject *Sender,
          LPDISPATCH pDisp, TVariant *URL);
    void __fastcall CppWebBrowser1DownloadBegin(TObject *Sender);
    void __fastcall CppWebBrowser1DownloadComplete(TObject *Sender);
    void __fastcall CppWebBrowser1NavigateComplete2(TObject *Sender,
          LPDISPATCH pDisp, TVariant *URL);
    void __fastcall CppWebBrowser1NewWindow2(TObject *Sender,
          LPDISPATCH *ppDisp, TOLEBOOL *Cancel);
    void __fastcall CppWebBrowser1ProgressChange(TObject *Sender,
          long Progress, long ProgressMax);
    void __fastcall CppWebBrowser1TitleChange(TObject *Sender, BSTR URL);
    void __fastcall CppWebBrowser1CommandStateChange(TObject *Sender,
          long Command, TOLEBOOL Enable);
    void __fastcall CppWebBrowser1Visible(TObject *Sender,
          TOLEBOOL Visible);
    void __fastcall ClearClick(TObject *Sender);
    void __fastcall GoClick(TObject *Sender);
    void __fastcall TraceClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall NewWindowClick(TObject *Sender);
    void __fastcall CloseWindowClick(TObject *Sender);
    void __fastcall BrowseClick(TObject *Sender);
    void __fastcall ViewSourceClick(TObject *Sender);
    void __fastcall CppWebBrowser1PropertyChange(TObject *Sender,
          BSTR URL);
    void __fastcall CppWebBrowser1StatusTextChange(TObject *Sender,
          BSTR URL);
    void __fastcall BitBtn2Click(TObject *Sender);
    void __fastcall NMHTTP1Success(CmdType Cmd);
private:	// User declarations
    AnsiString Last_Title;
public:		// User declarations
    TMainForm* Next_Form;
    TMainForm* Prev_Form;
    __fastcall TMainForm(TComponent* Owner);
    virtual __fastcall ~TMainForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
